package com.dsic.gj_erp.pc.dto;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.service.设备接口;
import com.dsic.gj_erp.pc.设备产能;
import lombok.Getter;
import lombok.Setter;

import java.util.concurrent.ConcurrentLinkedDeque;

@Getter
@Setter
public abstract class 设备 implements 设备接口 {
    protected String 设备编号;
    protected String 设备名称;
    protected double 白班设备产能;
    protected double 二班设备产能;
    protected double 双班合计产能;
    protected double 产能;
    protected volatile double 占用=0.0;
    protected ConcurrentLinkedDeque<String> 资源占用图纸表;
    protected ConcurrentLinkedDeque<Bom> 资源占用图表;
    protected String key;

    @Override
    public void 修正工作量(double 白班时长, double 二班时长) {
        this.产能=0;
        if (白班时长>0){
            this.产能+=白班时长*白班设备产能/7.0;
        }
        if (二班时长>0){
            this.产能+=二班时长*二班设备产能/7.0;
        }
    }

    public boolean 判断设备是否可以被占用(double 产量){
        return false;
    }

    @Override
    public void 占用设备(double 所需产能) {
        this.占用+=所需产能;
    }

    @Override
    public void 占用设备(String 占用源) {
        this.资源占用图纸表.add(占用源);
    }

    @Override
    public void 占用设备(Bom bom) {
        this.资源占用图纸表.add(bom.getTzbh());
        this.资源占用图表.add(bom);
    }

    public  设备(设备产能 _设备产能){
        this.设备编号= _设备产能.getCode();
        this.设备名称= _设备产能.get设备名称();
        this.白班设备产能= _设备产能.get白班设备产能();
        this.二班设备产能= _设备产能.get二班设备产能();
        this.双班合计产能=_设备产能.get双班合计产能();
        this.key=_设备产能.get套料图编码();
        this.资源占用图纸表=new ConcurrentLinkedDeque<>();
        this.资源占用图表=new ConcurrentLinkedDeque<>();
    }

    public 设备(Constant.设备产能 _设备产能){
        this.设备编号= _设备产能.设备编号;
        this.设备名称= _设备产能.设备名称;
        this.白班设备产能= _设备产能.白班设备产能;
        this.二班设备产能= _设备产能.二班设备产能;
        this.双班合计产能=_设备产能.get双班合计产能();
        this.资源占用图纸表=new ConcurrentLinkedDeque<>();
        this.资源占用图表=new ConcurrentLinkedDeque<>();
    }

    public static void main(String[] args) {
        int d=-7;
        DateTime offset = DateUtil.date().offset(DateField.DAY_OF_YEAR, -d);
        System.out.println(offset.toDateStr());
    }
}
