package com.dsic.gj_erp.service.jiuzhou;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.jiuzhou.Sljh;
import com.dsic.gj_erp.jiuzhoumapper.SljhMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class SljhService extends ServiceImpl<SljhMapper, Sljh> {

    @Async
    @EventListener
    public void save(List<DmYdjh> slYdjh){
        log.info("开始执行九州接口推送:{}",slYdjh);
        List<Sljh> collect = slYdjh.stream().map(Sljh::ofWithYdjh).collect(Collectors.toList());
        log.info("生成九州数据完成:{}",collect);
        try {
            this.saveBatch(collect);
        }catch (Exception e){
            e.printStackTrace();
        }
        log.info("推送完成");
    }
}
