package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.pgd.PgdPkjh;
import com.dsic.gj_erp.bean.pgd.PgdQgjh;
import com.dsic.gj_erp.bean.pgd.PgdQmjh;
import com.dsic.gj_erp.bean.pgd.Qmqz;
import com.dsic.gj_erp.mapper.pgd.PgdQmjhMapper;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.PgdQmjhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdQmjhServiceImpl extends ServiceImpl<PgdQmjhMapper, PgdQmjh> implements PgdQmjhService {

    @Autowired
    PgdQmjhMapper qmjhMapper;

    @Autowired
    DmYdjhLjService dmYdjhLjService;

    @Override
    public void saveQmPgdJs(List<DmYdjhLj> qmjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setQjsry((String) request.getAttribute("yhms"));
            e.setQjsrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setQjgZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);

    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdXd(List<DmYdjhLj> qmjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setQjgXfry((String) request.getAttribute("yhms"));
            e.setQjgXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setQscdw(f.getQscdw());
            e.setQscry(f.getQscry());
            e.setQjgZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdFk(List<DmYdjhLj> qmjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setQjgFkry((String) request.getAttribute("yhms"));
            e.setQjgFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setQjgZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    public void saveQmFk(List<DmYdjhLj> qmjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setQjgry(e.getQjgry());
            e.setQjgksrq(e.getQjgksrq());
            e.setQjgjsrq(e.getQjgjsrq());
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdXdBack(List<DmYdjhLj> qmjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setQjgXfry((String) request.getAttribute("yhms"));
            e.setQjgXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getQjgZt().equals("02")){
                e.setQjgZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
     public List<Qmqz>  selectQmByQgAndJh(Map map) {

        if((Boolean) map.get("qbs")){
            map.put("q","1");
        }
        if((Boolean) map.get("pkbs")){
            map.put("p","1");
        }
        if((Boolean) map.get("dmbs")){
            map.put("d","1");
        }
      return   qmjhMapper.selectQmByQgAndJh(map);
    }

    @Override
    public void insertQmList(Map map, HttpServletRequest request) {

        List<Qmqz> list =(ArrayList)map.get("list");
       String lx =(String)map.get("lx");
        String str= JSON.toJSONString(list);
        list= JSONObject.parseArray(str, Qmqz.class);
        List<DmYdjhLj> us =new ArrayList<>();
        for(Qmqz qmqz:list){
            DmYdjhLj ydjhLj=new DmYdjhLj();
            ydjhLj.setId(qmqz.getId());
            if(lx.equals("q")){
                ydjhLj.setQdr("Y");
            }else if (lx.equals("d")){
                ydjhLj.setDmdr("Y");
            }else if (lx.equals("p")){
                ydjhLj.setPkdr("Y");
            }

            us.add(ydjhLj);
        }
        dmYdjhLjService.updateBatchById(us);

    }

    @Override
    public void removeQmList(Map map, HttpServletRequest request) {
        List<Qmqz> list =(ArrayList)map.get("list");
        String lx =(String)map.get("lx");
        String str= JSON.toJSONString(list);
        list= JSONObject.parseArray(str, Qmqz.class);
        List<DmYdjhLj> us =new ArrayList<>();
        for(Qmqz qmqz:list){
            DmYdjhLj ydjhLj=new DmYdjhLj();
            ydjhLj.setId(qmqz.getId());
            if(lx.equals("q")){
                ydjhLj.setQdr("");
            }else if (lx.equals("d")){
                ydjhLj.setDmdr("");
            }else if (lx.equals("p")){
                ydjhLj.setPkdr("");
            }

            us.add(ydjhLj);
        }
        dmYdjhLjService.updateBatchById(us);
    }
}
