package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.bean.pgd.PgdDh;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.pgd.PgdSljhMapper;
import com.dsic.gj_erp.pc.Manager;
import com.dsic.gj_erp.service.pgd.PgdSljhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

import static com.dsic.gj_erp.pc.Manager.from;
import static com.dsic.gj_erp.pc.Manager.to;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
@AllArgsConstructor
public class PgdSljhServiceImpl extends ServiceImpl<PgdSljhMapper, PgdSljh> implements PgdSljhService {

    private final RedisTemplate<String,Object> redisTemplate;


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveSljhPg(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setDw(f.getDw());
            e.setScdw(f.getScdw());
            e.setScry(f.getScry());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveSljhPgBack(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setXfry("");
            e.setXfrq("");
            e.setZt("01");
            e.setDw("");
            e.setScdw("");
            e.setScry("");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveSljhPgdXd(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setJsry((String) request.getAttribute("yhms"));
            e.setJsrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveSljhPgdFk(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("04");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    public void saveSljhFk(List<PgdSljh> sljhs, HttpServletRequest request) {
        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("04");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveSljhPgdXdBack(List<PgdSljh> sljhs, HttpServletRequest request) {

        List<PgdSljh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdSljh e= new PgdSljh();
            e.setJsry("");
            e.setJsry("");
            e.setZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    public List<PgdSljh> 已排产上料计划装载(String ch, String pl, String fd, String tlth) {
        return list(Wrappers.<PgdSljh>lambdaQuery()
                .eq(PgdSljh::getCzbh,ch)
                .eq(PgdSljh::getPl,pl)
                .eq(PgdSljh::getFd,fd)
                .eq(PgdSljh::getTlth,tlth)
                .isNotNull(PgdSljh::getFkrq)
        );
    }

}
